#Compile Exe
#Register None
#Include "win32api.inc"

Type Note
    pitch       As Integer
    duration    As Integer
End Type

Sub pbOut(ByVal port_ As Integer, ByVal value_ As Integer)
    !mov ax         , value_
    !mov dx         , port_
    !out dx         , al
End Sub

Function pbIn(ByVal port_ As Integer) As Integer
    !mov dx         , port_
    !in  al         , dx
    !mov Function[0], al
End Function

Sub setfreq(ByVal hz As Integer)
    hz = 1193180 / hz
    pbOut &H43, &Hb6
    pbOut &H42, hz
    Shift Right hz, 8
    pbOut &H42, hz
End Sub

Sub playnote(notee As Note)

    pbOut &H61, pbIn(&H61) Or &H03
    setfreq 400 * (2 ^ (notee.pitch / 12.0))
    Sleep notee.duration
    pbOut &H61, pbIn(&H61) And Not &H03

End Sub

Function PBMain

    Dim i       As Integer
    Dim h       As Dword

    Dim notes(1 To 5) As Note

    notes(1).pitch = 4
    notes(1).duration = 500
    notes(2).pitch = 16
    notes(2).duration = 500
    notes(3).pitch = 12
    notes(3).duration = 500
    notes(4).pitch = 0
    notes(4).duration = 500
    notes(5).pitch = 7
    notes(5).duration = 1000

    h = CreateFile("\\.\giveio", %GENERIC_READ, 0, ByVal 0, _
                    %OPEN_EXISTING, %FILE_ATTRIBUTE_NORMAL, ByVal 0)
    If h = %INVALID_HANDLE_VALUE Then
        MsgBox "Couldn't access giveio device"
        Function = -1
        Exit Function
    End If
    CloseHandle h

    For i=1 To 5
        playnote notes(i)
    Next
    Function = 0
    MsgBox "done"

End Function
